
-- Testbench for the 2-Bit comparator.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY comparator_vhd_tst IS
END comparator_vhd_tst;

ARCHITECTURE comparator_arch OF comparator_vhd_tst IS                                                
	SIGNAL a : STD_LOGIC_VECTOR(1 DOWNTO 0);
	SIGNAL b : STD_LOGIC_VECTOR(1 DOWNTO 0);
	SIGNAL r : STD_LOGIC_VECTOR(2 DOWNTO 0);
	COMPONENT comparator
		PORT (
		a : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		b : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
		r : OUT STD_LOGIC_VECTOR(2 DOWNTO 0)
		);
	END COMPONENT;
	BEGIN
		i1 : comparator PORT MAP ( a => a, b => b, r => r );
		
	PROCESS                                                                                  
	BEGIN                                                        
      
		a <= "00"; b <= "00"; wait for 50 ns;
		a <= "00"; b <= "01"; wait for 50 ns;
		a <= "00"; b <= "10"; wait for 50 ns;
		a <= "00"; b <= "11"; wait for 50 ns;
		
		a <= "01"; b <= "00"; wait for 50 ns;
		a <= "01"; b <= "01"; wait for 50 ns;
		a <= "01"; b <= "10"; wait for 50 ns;
		a <= "01"; b <= "11"; wait for 50 ns;		
		
		a <= "10"; b <= "00"; wait for 50 ns;
		a <= "10"; b <= "01"; wait for 50 ns;
		a <= "10"; b <= "10"; wait for 50 ns;
		a <= "10"; b <= "11"; wait for 50 ns;		
		
		a <= "11"; b <= "00"; wait for 50 ns;
		a <= "11"; b <= "01"; wait for 50 ns;
		a <= "11"; b <= "10"; wait for 50 ns;
		a <= "11"; b <= "11"; wait for 50 ns;
		
		WAIT;                                                       
	END PROCESS;                                           
                               
END comparator_arch;
