

-- Testbench for the integer division.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY division_vhd_tst IS
END division_vhd_tst;

ARCHITECTURE division_arch OF division_vhd_tst IS                                                
	SIGNAL a : STD_LOGIC_VECTOR(31 DOWNTO 0);
	SIGNAL b : STD_LOGIC_VECTOR(31 DOWNTO 0);
	SIGNAL c : STD_LOGIC_VECTOR(31 DOWNTO 0);
	COMPONENT division
		PORT (
		a : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		b : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		c : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
		);
	END COMPONENT;
BEGIN
	i1 : division PORT MAP ( a, b, c );

	PROCESS                                                                                    
	BEGIN                                                        
			a <= "00000000000000000000000000000001"; -- a =  1.
			b <= "00000000000000000000000000000001"; -- b =  1.
			wait for 500 ns;			  
		  
			a <= "00000000000000000000000000110001"; -- a = 49.
			b <= "00000000000000000000000000000111"; -- b =  7.
			wait for 500 ns;	
			
			a <= "00000000000000000000000000100000"; -- a = 32.
			b <= "00000000000000000000000000010000"; -- b = 16.
			wait for 500 ns;		  
	WAIT;                                                       
	END PROCESS;                                                                                   
END division_arch;
