
-- Testbench for the integer multiplication.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY multiplication_vhd_tst IS
END multiplication_vhd_tst;

ARCHITECTURE multiplication_arch OF multiplication_vhd_tst IS                                                
	SIGNAL a : STD_LOGIC_VECTOR(31 DOWNTO 0);
	SIGNAL b : STD_LOGIC_VECTOR(31 DOWNTO 0);
	SIGNAL c : STD_LOGIC_VECTOR(31 DOWNTO 0);
	COMPONENT multiplication
		PORT (
		a : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		b : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
		c : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
		);
	END COMPONENT;
BEGIN
	i1 : multiplication PORT MAP ( a, b, c );

	PROCESS                                                                                    
	BEGIN                                                        
			a <= "00000000000000000000000000000000"; -- a =  0.
			b <= "00000000000000000000000000000000"; -- b =  0.
			wait for 500 ns;			  
		  
			a <= "00000000000000000000000000010001"; -- a = 17.
			b <= "00000000000000000000000000000101"; -- b =  5.
			wait for 500 ns;	
			
			a <= "00000000000000000000000000100000"; -- a = 32.
			b <= "00000000000000000000000000001101"; -- b = 13.
			wait for 500 ns;		  
	WAIT;                                                       
	END PROCESS;                                                                                   
END multiplication_arch;
