
-- 8x4-Bit RAM.
-- Tobias Schubert, 2011.

library ieee;                                               
use ieee.std_logic_1164.all;    
use ieee.std_logic_arith.all;

entity ram is 
	port 
		( 
		clk: in std_logic;                         -- We implement a "clocked" ram. 
		wr: in std_logic;                          -- wr = 1 -> write ram, wr = 0 -> read ram.
		address: in std_logic_vector (2 downto 0); -- 3 Bit address.
		din: in std_logic_vector (3 downto 0);     -- 4 Bit input.
		dout: out std_logic_vector (3 downto 0)    -- 4 Bit output.
		); 
end ram; 

architecture behavior of ram is
	signal internalAddress: std_logic_vector (2 downto 0); 
	subtype cell is std_logic_vector (3 downto 0); 
	type cellVec is array (7 downto 0) of cell;
	signal memory: cellVec;
begin
	process ( clk )
	begin
		if (clk = '1') then
			if (wr = '1') then memory(conv_integer(unsigned(address))) <= din; end if;
			internalAddress <= address;
		end if; 
	end process;
	
	dout <= memory(conv_integer(unsigned(internalAddress)));
end behavior;