
-- Testbench for our RAM.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY ram_vhd_tst IS
END ram_vhd_tst;

ARCHITECTURE ram_arch OF ram_vhd_tst IS
	SIGNAL clk: STD_LOGIC;
	SIGNAL address : STD_LOGIC_VECTOR(2 DOWNTO 0);
	SIGNAL din : STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL dout : STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL wr : STD_LOGIC;
	COMPONENT ram
		PORT (
		clk: iN STD_LOGIC;
		address : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
		din : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		dout : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		wr : IN STD_LOGIC
		);
	END COMPONENT;
BEGIN
	i1 : ram PORT MAP ( clk => clk, address => address, din => din, dout => dout,	wr => wr	);

	PROCESS
	BEGIN
		clk <= '0';
		wait for 50 ns;
		clk <= '1';
		wait for 50 ns;
	END PROCESS;
	
	PROCESS                                                                                  
	BEGIN          
	
		wr <= '1';
	
		din <= "0001"; address <= "000"; wait for 75 ns;
		din <= "0010"; address <= "001"; wait for 100 ns;		
		din <= "0100"; address <= "010"; wait for 100 ns;
		din <= "0110"; address <= "011"; wait for 100 ns;
		din <= "1000"; address <= "100"; wait for 100 ns;
		din <= "1010"; address <= "101"; wait for 100 ns;
		din <= "1100"; address <= "110"; wait for 100 ns;
		din <= "1110"; address <= "111"; wait for 100 ns;
		
		wr <= '0'; 
		
		address <= "111"; wait for 100 ns;			
		address <= "110"; wait for 100 ns;
		address <= "101"; wait for 100 ns;
		address <= "100"; wait for 100 ns;
		address <= "011"; wait for 100 ns;
		address <= "010"; wait for 100 ns;
		address <= "001"; wait for 100 ns;
		address <= "000"; wait for 100 ns;
		
		WAIT;                                                       
	END PROCESS;                                                                               
END ram_arch;
