
-- 4-Bit Shifter.
-- Tobias Schubert, 2011.

-- s = 00 -> keep current value.
-- s = 01 -> shift left.
-- s = 10 -> shift right.
-- s = 11 -> initialize using a.

library ieee;                                               
use ieee.std_logic_1164.all;    

entity shifter is
	port 
		( 
		clk: in std_logic;
		a: in std_logic_vector (3 downto 0);
		s: in std_logic_vector (1 downto 0);
		b: out std_logic_vector (3 downto 0) 
		);
end shifter;

architecture behavior of shifter is
	signal x : std_logic_vector (3 downto 0); 
begin
	process ( clk )
	begin
		if clk = '1' then
			if s /= "00" then
				if s = "11" then
					x <= a;
				else
					if s = "01" then x <= (x(2 downto 0) & '0'); else x <= ('0' & x(3 downto 1)); end if;
				end if;
			end if;
		end if;
	end process;
	b <= x;
end behavior;