
-- Testbench for the 4-Bit shifter.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY shifter_vhd_tst IS
END shifter_vhd_tst;

ARCHITECTURE shifter_arch OF shifter_vhd_tst IS                                                 
	SIGNAL a : STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL b : STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL s : STD_LOGIC_VECTOR(1 DOWNTO 0);
	SIGNAL clk : STD_LOGIC;
	COMPONENT shifter
		PORT (
		clk : IN STD_LOGIC; 
		a : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		b : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		s : IN STD_LOGIC_VECTOR(1 DOWNTO 0)
		);
	END COMPONENT;
BEGIN
	i1 : shifter PORT MAP ( clk => clk, a => a, b => b, s => s );
	
	PROCESS
	BEGIN
		clk <= '0'; wait for 50 ns;
		clk <= '1'; wait for 50 ns;
	END PROCESS;
	
	PROCESS                                                                                 
	BEGIN                          
		a <= "1111";
		s <= "11"; wait for 75 ns;
		s <= "01"; wait for 100 ns;
		s <= "10"; wait for 100 ns;
		s <= "00"; wait for 100 ns;
		s <= "10"; wait for 100 ns;
		s <= "00"; wait for 100 ns;
		s <= "01"; wait for 100 ns;
		s <= "00"; wait for 100 ns;
		a <= "1001";
      s <= "11";
		WAIT;                                                       
	END PROCESS;                                                                                    
END shifter_arch;
