
-- Testbench for the full adder.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY fullAdder_vhd_tst IS
END fullAdder_vhd_tst;

ARCHITECTURE fullAdder_arch OF fullAdder_vhd_tst IS
	SIGNAL a : STD_LOGIC;
	SIGNAL b : STD_LOGIC;
	SIGNAL cin : STD_LOGIC;
	SIGNAL cout : STD_LOGIC;
	SIGNAL sum : STD_LOGIC;
	COMPONENT fullAdder
		PORT (
		a : IN STD_LOGIC;
		b : IN STD_LOGIC;
		cin : IN STD_LOGIC;
		cout : OUT STD_LOGIC;
		sum : OUT STD_LOGIC
		);
	END COMPONENT;
BEGIN
	i1 : fullAdder
	PORT MAP ( a => a, b => b,	cin => cin,	cout => cout, sum => sum );

	PROCESS
	BEGIN
		a <= '0';
		wait for 160 ns;
		a <= '1';
		wait for 160 ns;		
	END PROCESS;
	
	PROCESS
	BEGIN
		b <= '0';
		wait for 80 ns;
		b <= '1';
		wait for 80 ns;		
	END PROCESS;

	PROCESS
	BEGIN
		cin <= '0';
		wait for 40 ns;
		cin <= '1';
		wait for 40 ns;		
	END PROCESS;	
	                                                                     
END fullAdder_arch;
