
-- Testbench for temperature.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY temperature_vhd_tst IS
END temperature_vhd_tst;

ARCHITECTURE temperature_arch OF temperature_vhd_tst IS                                                  
	SIGNAL a : STD_LOGIC;
	SIGNAL b : STD_LOGIC;
	SIGNAL c : STD_LOGIC;
	SIGNAL d : STD_LOGIC;
	SIGNAL val : STD_LOGIC_VECTOR(6 DOWNTO 0);
	COMPONENT temperature
		PORT (
		a : OUT STD_LOGIC;
		b : OUT STD_LOGIC;
		c : OUT STD_LOGIC;
		d : OUT STD_LOGIC;
		val : IN STD_LOGIC_VECTOR(6 DOWNTO 0)
		);
	END COMPONENT;
BEGIN
	i1 : temperature
	PORT MAP ( a => a, b => b, c => c, d => d, val => val );
	
	PROCESS                                                                                    
	BEGIN                                                        
		val <= "1000000"; -- 64.
		wait for 100 ns;
		val <= "0100000"; -- 32.
		wait for 100 ns;
		val <= "1001010"; -- 74.
		wait for 100 ns;
		val <= "0110111"; -- 55.
		WAIT;                                                       
	END PROCESS;                                                                                
END temperature_arch;
