
-- Full Adder, Slide 115.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;    

entity fullAdder is
	port ( a, b, cin: in std_logic; sum, cout: out std_logic );
end fullAdder;

architecture behavior of fullAdder is
	signal i1, i2: std_logic;
begin
	P1: process ( a, b ) 
	begin
		i1 <= a xor b after 10ns;
		i2 <= a and b after 10ns;
	end process;

	P2: process ( i1, i2, cin ) 
	begin
		sum <= i1 xor cin;
		cout <= i2 or (i1 and cin);
	end process;
end behavior;