
-- Testbench for the full adder.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY fullAdder_vhd_tst IS
END fullAdder_vhd_tst;

ARCHITECTURE fullAdder_arch OF fullAdder_vhd_tst IS
	SIGNAL a : STD_LOGIC;
	SIGNAL b : STD_LOGIC;
	SIGNAL cin : STD_LOGIC;
	SIGNAL cout : STD_LOGIC;
	SIGNAL sum : STD_LOGIC;
	COMPONENT fullAdder
		PORT (
		a : IN STD_LOGIC;
		b : IN STD_LOGIC;
		cin : IN STD_LOGIC;
		cout : OUT STD_LOGIC;
		sum : OUT STD_LOGIC
		);
	END COMPONENT;
BEGIN
	i1 : fullAdder
	PORT MAP ( a => a, b => b,	cin => cin,	cout => cout, sum => sum );

	PROCESS
		VARIABLE cnt : STD_LOGIC := '1';
		VARIABLE num : integer := 0; 
	BEGIN
		LOOP
			if cnt = '1' then cnt := '0'; else cnt := '1'; end if;
			num := num + 1;
			a <= cnt;
			wait for 160 ns;
			exit when num > 9;
		END LOOP;
	END PROCESS;
	
	PROCESS
		VARIABLE cnt : STD_LOGIC := '1';
		VARIABLE num : integer := 0; 
	BEGIN
		WHILE num <= 9 LOOP
			if cnt = '1' then cnt := '0'; else cnt := '1'; end if;
			num := num + 1;
			b <= cnt;
			wait for 80 ns;		
		END LOOP; 
	END PROCESS;

	PROCESS
		VARIABLE cnt : STD_LOGIC := '1';	
	BEGIN
		FOR num IN 1 TO 9 LOOP
			if cnt = '1' then cnt := '0'; else cnt := '1'; end if;
			cin <= cnt;
			wait for 40 ns;		
		END LOOP;
	END PROCESS;	
	                                                                     
END fullAdder_arch;
