
-- Testbench n-Bit Shift Register.
-- Tobias Schubert

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY shift_register_nbit_vhd_tst IS
END shift_register_nbit_vhd_tst;

ARCHITECTURE shift_register_nbit_arch OF shift_register_nbit_vhd_tst IS                                                
	SIGNAL clk : STD_LOGIC;
	SIGNAL din : STD_LOGIC;
	SIGNAL dout : STD_LOGIC;
	SIGNAL reset : STD_LOGIC;
	SIGNAL set : STD_LOGIC;
	COMPONENT shift_register_nbit
		GENERIC ( n : POSITIVE );
		PORT (
		clk : IN STD_LOGIC;
		din : IN STD_LOGIC;
		dout : OUT STD_LOGIC;
		reset : IN STD_LOGIC;
		set : IN STD_LOGIC
		);
	END COMPONENT;
BEGIN
	i1 : shift_register_nbit 
		GENERIC MAP ( 7 )
		PORT MAP ( clk => clk, din => din, dout => dout, reset => reset, set => set );
		
	PROCESS
	BEGIN
		clk <= '0';
		wait for 40 ns;
		clk <= '1';
		wait for 40 ns;
	END PROCESS;
		
	PROCESS                                                                                  
	BEGIN                                                        
      reset <= '1';
		set <= '0';
		din <= '1';
		wait for 100 ns;
		reset <= '0';
		wait for 30 ns;
		din <= '0';
		wait for 1300 ns;
		set <= '1';
		wait for 70 ns;
		set <= '0';		
		WAIT;                                                       
	END PROCESS;                                           
                             
END shift_register_nbit_arch;
