
-- Testbench for the halfadder schematic.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY halfadder_vhd_tst IS
END halfadder_vhd_tst;

ARCHITECTURE halfadder_arch OF halfadder_vhd_tst IS                                        
	SIGNAL a : STD_LOGIC;
	SIGNAL b : STD_LOGIC;
	SIGNAL cout : STD_LOGIC;
	SIGNAL sum : STD_LOGIC;
	COMPONENT halfadder 
		PORT ( a, b : IN STD_LOGIC; cout, sum : OUT STD_LOGIC );
	END COMPONENT;
BEGIN
	i1 : halfadder
	PORT MAP ( a, b, cout, sum ); 
	
	PROCESS                                     
	BEGIN                     

		report "Validating...";
		
		a <= '0';
		b <= '0'; 
		wait for 50ns;

		assert (cout = '1' and sum = '0')
			report "Error 0/0!";
		
		a <= '0';
		b <= '1'; 
		wait for 50ns;
		
		assert (cout = '0' and sum = '1')
			report "Error 0/1!";

		a <= '1';
		b <= '0'; 
		wait for 50ns;

		assert (cout = '0' and sum = '1')
			report "Error 1/0!";		
		
		a <= '1';
		b <= '1'; 
		wait for 50ns;

		assert (cout = '0' and sum = '0')
			report "Error 1/1!";
		
		report "Done...";

		WAIT;                                                       
		END PROCESS;                                                                            
END halfadder_arch;
