
-- Full Adder, Slides 22/23.
-- Tobias Schubert, 2011.

entity fullAdder is
	port ( a, b, cin: in bit; sum, cout: out bit );
end fullAdder;

architecture structure of fullAdder is
	component halfAdder port ( a, b: in bit; sum, cout: out bit ); end component;
	component orGate port ( a, b: in bit; c: out bit ); end component;
	signal x, y, z: bit;
begin
	i1: halfAdder port map ( a, b, x, y );
	i2: halfAdder port map ( x, cin, sum, z );
	o1: orGate port map ( y, z, cout );
end structure;

entity halfAdder is
	port ( a, b: in bit; sum, cout: out bit );
end halfAdder;

architecture behavior of halfAdder is
begin
	sum <= a xor b;
	cout <= a and b;
end behavior;

entity orGate is
	port ( a, b: in bit; c: out bit );
end orGate;

architecture behavior of orGate is
begin
	c <= '1' when (a = '1' or b = '1') else '0';
end behavior;