
-- Testbench for the multiplexer.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY mux4to1_vhd_tst IS
END mux4to1_vhd_tst;

ARCHITECTURE mux4to1_arch OF mux4to1_vhd_tst IS
SIGNAL i0 : STD_LOGIC;
SIGNAL i1 : STD_LOGIC;
SIGNAL i2 : STD_LOGIC;
SIGNAL i3 : STD_LOGIC;
SIGNAL otp : STD_LOGIC;
SIGNAL sel : STD_LOGIC_VECTOR(1 DOWNTO 0);
COMPONENT mux4to1
	PORT (
	i3 : IN STD_LOGIC;
	i2 : IN STD_LOGIC;
	i1 : IN STD_LOGIC;
	i0 : IN STD_LOGIC;
	sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
	otp : OUT STD_LOGIC
	);
END COMPONENT;
BEGIN
	c1 : mux4to1 PORT MAP ( i3, i2, i1, i0, sel, otp );

	PROCESS                                               
   BEGIN            
		i0 <= '0';
		i1 <= '0';
		i2 <= '0';
		i3 <= '0';
		wait for 20ns;	
		
		i0 <= '1';
		sel <= "00";
		wait for 20ns;
		i0 <= '0';
		wait for 20ns;		
	
		i1 <= '1';
		sel <= "01";
		wait for 20ns;		
		i1 <= '0';
		wait for 20ns;				
		
		i2 <= '1';
		sel <= "10";
		wait for 20ns;
		i2 <= '0';
		wait for 20ns;		
		
		i3 <= '1';
		sel <= "11";
		wait for 20ns;
		i3 <= '0';
		wait for 20ns;				
		
		WAIT;                                                       
	END PROCESS;
END mux4to1_arch;
