
-- Testbench for the DFF.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY flipflop_vhd_tst IS
END flipflop_vhd_tst;

ARCHITECTURE flipflop_arch OF flipflop_vhd_tst IS                                               
	SIGNAL clk, data, q, reset, set : STD_LOGIC;

	COMPONENT flipflop
		PORT (
		clk : IN STD_LOGIC;
		data : IN STD_LOGIC;
		q : OUT STD_LOGIC;
		reset : IN STD_LOGIC;
		set : IN STD_LOGIC
		);	
	END COMPONENT;
	
BEGIN
	i1 : flipflop
	PORT MAP ( clk => clk, data => data, q => q, reset => reset, set => set );

	PROCESS                                                                                  
	BEGIN          
		reset <= '0';
		set <= '0';
		data <= '0';
		clk <= '0';
		wait for 10 ns;
	
      reset <= '1'; wait for 20 ns; reset <= '0';
		wait for 20 ns;
		
		data <= '1';
		wait for 10 ns;
		clk <= '1'; 
		wait for 20 ns; 
		
		data <= '0';
		clk <= '0';
		wait for 20 ns;
		clk <= '1';
		wait for 20 ns;
		clk <= '0';
		wait for 20 ns;
		
		set <= '1';
		wait for 50 ns;
		
		WAIT;                                                       
	END PROCESS;                                           
	
END flipflop_arch;
