
-- Testbench for the multiplexer.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY mux_4_to_1_8bit_vhd_tst IS
END mux_4_to_1_8bit_vhd_tst;

ARCHITECTURE mux_4_to_1_8bit_arch OF mux_4_to_1_8bit_vhd_tst IS                                                  
	SIGNAL i0 : STD_LOGIC_VECTOR(7 DOWNTO 0);
	SIGNAL i1 : STD_LOGIC_VECTOR(7 DOWNTO 0);
	SIGNAL i2 : STD_LOGIC_VECTOR(7 DOWNTO 0);
	SIGNAL i3 : STD_LOGIC_VECTOR(7 DOWNTO 0);
	SIGNAL otp : STD_LOGIC_VECTOR(7 DOWNTO 0);
	SIGNAL sel : STD_LOGIC_VECTOR(1 DOWNTO 0);
	COMPONENT mux_4_to_1_8bit
		PORT (
		i0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		i1 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		i2 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		i3 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		otp : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		sel : IN STD_LOGIC_VECTOR(1 DOWNTO 0)
		);
	END COMPONENT;
BEGIN
	c1 : mux_4_to_1_8bit
	PORT MAP ( i0 => i0, i1 => i1, i2 => i2, i3 => i3, otp => otp, sel => sel );
	
	PROCESS                                               
	BEGIN
		i0 <= "00010000";
		i1 <= "00001000";
		i2 <= "00000100";
		i3 <= "00000010";
		sel <= "00";
		wait for 50 ns;
		
		i0 <= "00000000";
		wait for 50 ns;
		
		sel <= "11";
		wait for 50 ns;
		
		sel <= "01";
		wait for 50 ns;
		
		sel <= "10";
		wait for 50 ns;
		
		WAIT;                                                       
	END PROCESS;                                           
                                         
END mux_4_to_1_8bit_arch;
