
-- 4-Bit Shift Register, Slides 90 to 91.
-- Tobias Schubert, 2011.

library ieee;
use ieee.std_logic_1164.all;

entity shift_register_4bit is
	port ( din, clk, set, reset: in std_logic; dout: out std_logic );
end shift_register_4bit;

architecture structural of shift_register_4bit is
	component flipflop
		port ( data, clk, set, reset: in std_logic; q: out std_logic );
	end component;
	signal T: std_logic_vector (2 downto 0);
begin
	bit3: flipflop port map ( din, clk, set, reset, T(2) );
	bit2: flipflop port map ( T(2), clk, set, reset, T(1) );
	bit1: flipflop port map ( T(1), clk, set, reset, T(0) );
	bit0: flipflop port map ( T(0), clk, set, reset, dout );
end structural;

library ieee;
use ieee.std_logic_1164.all;

entity flipflop is
	port ( data, clk, set, reset: in std_logic; q: out std_logic );
end flipflop;

architecture behavior of flipflop is
begin
	process ( clk, set, reset )
	begin
		if reset = '1' then
			q <= '0';
		elsif set = '1' then
			q <= '1';
		elsif (clk'event and clk = '1') then
			q <= data;
		end if;
	end process;
end behavior;