
-- Testbench for the shift register.
-- Tobias Schubert, 2011.

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY shift_register_4bit_vhd_tst IS
END shift_register_4bit_vhd_tst;

ARCHITECTURE shift_register_4bit_arch OF shift_register_4bit_vhd_tst IS                                             
	SIGNAL clk : STD_LOGIC;
	SIGNAL din : STD_LOGIC;
	SIGNAL dout : STD_LOGIC;
	SIGNAL reset : STD_LOGIC;
	SIGNAL set : STD_LOGIC;
	COMPONENT shift_register_4bit
		PORT (
		clk : IN STD_LOGIC;
		din : IN STD_LOGIC;
		dout : OUT STD_LOGIC;
		reset : IN STD_LOGIC;
		set : IN STD_LOGIC
		);
	END COMPONENT;
BEGIN
	i1 : shift_register_4bit
	PORT MAP ( clk => clk, din => din, dout => dout, reset => reset, set => set );

	PROCESS
	BEGIN
		clk <= '0';
		wait for 50 ns;
		clk <= '1';
		wait for 50 ns;
	END PROCESS;
	
	PROCESS                                                                                 
	BEGIN                                                        
      set <= '0';
		reset <= '0';
		din <= '0';
		wait for 20 ns;

		reset <= '1';
		wait for 50 ns;
		reset <= '0';
		
		din <= '1';
		wait for 100 ns;
		din <= '0';
		wait for 390 ns;
		
		set <= '1';
		wait for 50 ns;
		set <= '0';
		wait for 100 ns;
		reset <= '1';
		wait for 50 ns;
		reset <= '0';
		
		WAIT;                                                       
	END PROCESS;                                           
	                                 
END shift_register_4bit_arch;
